package com.fp.persistence.parmas.soli;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMSOLICITUDGUARDIAS*/
@Entity(name="TarmSolicitudGuardias")
@Table(name="TARMSOLICITUDGUARDIAS")
public class TarmSolicitudGuardias extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmSolicitudGuardias
*/
@EmbeddedId
private TarmSolicitudGuardiasKey pk;
/**Contructor por defecto*/
public TarmSolicitudGuardias(){
}
/**Contructor de TarmSolicitudGuardias
@param pPk Clave Primaria del entity
*/
public TarmSolicitudGuardias(TarmSolicitudGuardiasKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmSolicitudGuardias
*/
public static TarmSolicitudGuardias find(EntityManager pEntityManager,TarmSolicitudGuardiasKey pKey) throws Exception{
    TarmSolicitudGuardias obj = pEntityManager.find(TarmSolicitudGuardias.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmSolicitudGuardias
@return El objeto que referencia a la Clave primaria de TarmSolicitudGuardias
*/
public TarmSolicitudGuardiasKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmSolicitudGuardias
@param pPk El objeto que referencia a la nueva Clave primaria de TarmSolicitudGuardias
*/
public void setPk(TarmSolicitudGuardiasKey pPk){
  pk=pPk;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmSolicitudGuardias))return false;
    TarmSolicitudGuardias that = (TarmSolicitudGuardias) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmSolicitudGuardias
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmSolicitudGuardias
*/
public Object createInstance(){
 TarmSolicitudGuardias instance=new TarmSolicitudGuardias();	
 instance.setPk(new TarmSolicitudGuardiasKey());
 return instance;
}
/**Clona la entidad TarmSolicitudGuardias
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmSolicitudGuardias p=(TarmSolicitudGuardias)this.clone();
  p.setPk((TarmSolicitudGuardiasKey)this.pk.cloneMe());
  return p;
}
}
